package edu.gmu.cs;

import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

import java.util.*;

public class GraphTest {

    Graph<String> graph;

    @Before
    public void setup() {
        Set<String> vertices = new HashSet<String>();
        vertices.add("A");
        vertices.add("B");
        vertices.add("C");
        vertices.add("D");
        vertices.add("E");
        vertices.add("F");
        vertices.add("G");

        graph = new Graph<String>(vertices);

        graph.addEdge("A", "B", 5);
        graph.addEdge("A", "C", 2);
        graph.addEdge("B", "D", 3);
        graph.addEdge("B", "G", 12);
        graph.addEdge("C", "B", 2);
        graph.addEdge("D", "C", 1);
        graph.addEdge("D", "E", 3);
        graph.addEdge("D", "F", 1);
        graph.addEdge("D", "G", 6);
        graph.addEdge("E", "G", 3);
        graph.addEdge("F", "G", 4);
    }

    @Test
    public void findShortestPath() {
        Assert.assertEquals(Arrays.asList("A", "C", "B", "D", "F", "G"),
                            graph.findShortestPath("A", "G"));
    }
}
